#include "multiprec.h"

/** @addtogroup multiprec
 *  @{
 */
/** @addtogroup comparison
 *  @{
 */


/**
 * ¿ĹƱΤ羮Ӥ
 * @param lhs Ƚꤹstruct multiprecؤΥݥ
 * @param rhs Ƚꤹstruct multiprecؤΥݥ
 *
 * @retval 1 |<lhs>|礭
 * @retval 0 |<lhs>||<rhs>|
 * @retval -1 |<rhs>|礭 
 */
inline int
ymp_compare_abs(mp_cref_t lhs, mp_cref_t rhs)
{
  if (lhs->used > rhs->used)
    {
      return 1;
    }
  else if (lhs->used < rhs->used)
    {
      return -1;
    }
  else
    {
      size_t i;
      for (i=lhs->used; i-- > 0; )
	{
	  if (lhs->digits[i] > rhs->digits[i]) return 1;
	  else if (lhs->digits[i] < rhs->digits[i]) return -1;
	}
    }
  return 0;
}


/**
 * ¿ĹƱΤ羮Ӥ
 * @param lhs Ƚꤹstruct multiprecؤΥݥ
 * @param rhs Ƚꤹstruct multiprecؤΥݥ
 *
 * @retval 1 <lhs>礭
 * @retval 0 <lhs><rhs>
 * @retval -1 <rhs>礭 
 */
int
ymp_compare(mp_cref_t lhs, mp_cref_t rhs)
{
  if (lhs->sign != rhs->sign)
    return rhs->sign - lhs->sign;
  else if (lhs->sign)
    return ymp_compare_abs(rhs, lhs);
  else
    return ymp_compare_abs(lhs, rhs);
}

/**
 * ¿Ĺ@ref digit_t羮Ӥ
 * @param lhs Ƚꤹstruct multiprecؤΥݥ
 * @param rhs Ƚꤹdigit_t
 *
 * @retval 1 <lhs>礭
 * @retval 0 <lhs><rhs>
 * @retval -1 <rhs>礭 
 */
int
ymp_compare_digit(mp_cref_t lhs, digit_t rhs)
{
  if (lhs->sign) return -1;

  if (lhs->used > 1) return 1;
  else if (lhs->used == 1)
    {
      if (lhs->digits[0] > rhs) return 1;
      else if (lhs->digits[0] < rhs) return -1;
      else return 0;
    }
  else return -(rhs!=0);
}


/**
 * ¿Ĺ0ɤȽ
 * @param self Ƚꤹstruct multiprecؤΥݥ
 * @return ¿Ĺͤ0Ǥʤ顢0֤. Ǥʤʤ0֤
 */
int
ymp_is_zero(mp_cref_t self)
{
  return !self || !self->used || (self->used==1 && !self->digits[0]);
}

/**
 * ¿ĹɤȽ
 * @param self Ƚꤹstruct multiprecؤΥݥ
 * @return ¿Ĺͤʤ顢0֤. ʤ0֤
 */
int
ymp_is_even(mp_cref_t self)
{
  return !self || !self->used || !(self->digits[0] & 0x01);
}

/** @} */
/** @} */
