#include "multiprec.h"
#include <string.h>
#include <math.h>

/** @addtogroup multiprec
 * @{ */
/** @addtogroup construction
 * @{ */

/**
 * ¿ĹɸҤͤǽ
 *
 * 줿selfͤȤƤ0Ǥ롣
 * @ref MULTIPREC_INITIALIZERˤƱ
 *
 * @param self ٤struct multiprecؤΥݥ
 * @pre self̤ΤȡѤξ硢꡼꡼롣
 */
inline void
ymp_initialize(mp_ref_t self)
{
  static const struct multiprec prototype = MULTIPREC_INITIALIZER;
  memcpy(self, &prototype, sizeof(struct multiprec));
}


/** 
 * ¿Ĺ˴digit롣
 * @param self ˴¿ĹؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 */
inline void
ymp_destroy(mp_ref_t self)
{
  YMP_FREE_DIGITS(self);
}

/**
 * Ѥ¿ĹƤӽ֤ˤ롣
 *
 * äơͤȤƤ0Ȥʤ롣
 * @param self ¿ĹؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 */
void
ymp_reinitialize(mp_ref_t self)
{
  ymp_destroy(self);
  ymp_initialize(self);
}


/** 
 * ǥץԡˤ¿Ĺ
 * @param self ¿Ĺ
 * @param other ԡ¿Ĺ
 * @pre self̤ΤȡѤξ硢꡼꡼롣
 * @pre otherϽѤΤȡ̤ξư
 */
inline void
ymp_initialize_by_mp(mp_ref_t self, mp_cref_t other)
{
  memcpy(self, other, sizeof(*self)-sizeof(digit_t*));
  YMP_ALLOC_DIGITS(self, self->len);
  memcpy(self->digits, other->digits, sizeof(digit_t)*self->used);
}

/**
 * ¿Ĺ򡢰digitݤ֤ǽ@ref digit_t
 * @param self ¿ĹؤΥݥ
 * @param len ݤdigitǿ
 * @param d 
 * @pre self̤ΤȡѤξ硢꡼꡼롣
 */
inline void
ymp_reserve_and_initialize_by_digit(mp_ref_t self, size_t len, digit_t d)
{
  self->sign = positive_sign;
  YMP_ALLOC_DIGITS(self, len);
  self->used = 1;
  self->digits[0] = d;
}

/**
 * ¿Ĺ@ref digit_tƽ
 * @param self ¿ĹؤΥݥ
 * @param d 
 * @pre self̤ΤȡѤξ硢꡼꡼롣
 */
void 
ymp_initialize_by_digit(mp_ref_t self, digit_t d)
{
  ymp_reserve_and_initialize_by_digit(self, 1, d);
}

/**
 * ¿Ĺ򡢰digitݤ֤ǽ0
 * @param self ¿ĹؤΥݥ
 * @param len ݤdigitǿ
 * @pre self̤ΤȡѤξ硢꡼꡼롣
 */
void
ymp_reserve_and_initialize(mp_ref_t self, size_t len)
{
  ymp_reserve_and_initialize_by_digit(self, len, 0);
}


/**
 * ¿Ĺ@ref digit_tˤ
 *
 * @param self ¿ĹؤΥݥ
 * @param len arrayݥȤǿ
 * @param array ¿ĹγƷɽdigit_tƬؤΥݥ
 * @pre self̤ΤȡѤξ硢꡼꡼롣
 */
void
ymp_initialize_by_array(mp_ref_t self, size_t len, const digit_t *array)
{
  self->sign = positive_sign;
  self->used = len;
  YMP_ALLOC_DIGITS(self, len);
  memcpy(self->digits, array, len);
} 


/**
 * @internal
 * @brief դηΰ٤åݥꥷ
 * @ref define_initialize_integraltypeϤåݥꥷ
 * valåself->signꤹ롣
 * @param self ꤹstruct multiprecؤΥݥ
 * @param val 
 * @post valͤˤʤ롣Ĥޤ val := abs(val)
 */
#define to_sign_check(self, val)		\
  if (val >= 0)					\
    {						\
      self->sign = positive_sign;		\
    }						\
  else						\
    {						\
      self->sign = negative_sign;		\
      val = -val;				\
    }

/**
 * @internal
 * @brief ̵ηΰ٤åݥꥷ
 * @ref define_initialize_integraltypeϤåݥꥷ
 * self->signꤹ
 * @param self ꤹstruct multiprecؤΥݥ
 * @param val 
*/
#define not_to_sign_check(self, val) (void)(self->sign = positive_sign)



/**
 * @internal
 * @brief ¿Ĺؤ¹
 * @param type 
 * @param self struct multiprecؤΥݥ
 * @param val typeα
 * @param allocator ymp_reserve()ߴΥ󥿡եallocator
 * @param sign_checker ݥꥷ
 */
#define do_assign_integral_value(type, self, val, allocator, sign_check) \
  static const size_t len						 \
    = sizeof(type)/sizeof(digit_t)+!!(sizeof(type)%sizeof(digit_t));	 \
  size_t i;								 \
									 \
  sign_check(self, val);						 \
  allocator(self, len);							 \
									 \
  for (i=0; val; ++i)							 \
    {									 \
      self->digits[i] = (digit_t)val & DIGIT_MAX;			 \
      val >>= DIGIT_BIT;						 \
    }									 \
  self->used = i;


/**
 * @internal
 * ¿Ĺƽؿƥץ졼
 * @param type 
 * @param postfix ؿ̾դ
 * @param sign_check åݥꥷ
 *                   (@ref to_sign_checkޤ@ref not_to_sign_check)
 */
#define define_ymp_initialize_integral_type(type, postfix, sign_check)	   \
/**									   \
  ¿Ĺ type ͤƽ				   \
  @param self ¿ĹؤΥݥ			   \
  @param val 							   \
  @pre self̤ΤȡѤξ硢꡼꡼롣	   \
 */									   \
void ymp_initialize_by_##postfix(mp_ref_t self, type val)		   \
{									   \
  do_assign_integral_value(type, self, val, YMP_ALLOC_DIGITS, sign_check); \
}

define_ymp_initialize_integral_type(signed char, char, to_sign_check);
define_ymp_initialize_integral_type(short, short, to_sign_check);
define_ymp_initialize_integral_type(int, int, to_sign_check);
define_ymp_initialize_integral_type(long, long, to_sign_check);
define_ymp_initialize_integral_type(unsigned char, uchar, not_to_sign_check);
define_ymp_initialize_integral_type(unsigned short, ushort, not_to_sign_check);
define_ymp_initialize_integral_type(unsigned int, uint, not_to_sign_check);
define_ymp_initialize_integral_type(unsigned long, ulong, not_to_sign_check);
#ifdef C99
define_ymp_initialize_integral_type(intmax_t, intmax, to_sign_check);
define_ymp_initialize_integral_type(uintmax_t, uintmax, to_sign_check);
#endif


#define do_assign_floating_value(type, sys_suffix, funcname, allocator)	\
  size_t i, len;							\
  type val2;								\
									\
  if (!isfinite(val))							\
    {									\
      ymp_error(funcname, ": ҤͭͤǤʤ");			\
      return;								\
    }									\
									\
  if ( val >= 0)							\
    {									\
      self->sign = positive_sign;					\
      val = floor##sys_suffix(val);					\
    }									\
  else									\
    {									\
      self->sign = negative_sign;					\
      val = -ceil##sys_suffix(val);					\
    }									\
									\
  for (len=0, val2=val; val2!=0.0; ++len)				\
    {									\
      val2 = floor##sys_suffix(val2/MULTIPREC_RADIX);			\
    }									\
									\
  allocator(self, len);							\
									\
  for (i=0; i<len; ++i)							\
    {									\
      self->digits[i] = (digit_t)val;					\
      val /= MULTIPREC_RADIX;						\
    }									\
  self->used = len;


/**
 * ¿Ĺdoubleͤƽ
 *
 * doubleͤʬ롣
 *  @param self ¿ĹؤΥݥ
 *  @param val 
 *  @pre self̤ΤȡѤξ硢꡼꡼롣
 */
void ymp_initialize_by_double(mp_ref_t self, double val)
{
  do_assign_floating_value(double,, "ymp_initialize_by_double", YMP_ALLOC_DIGITS);
}




/** 
 * ǥץԡˤ¿Ĺ򿷵
 * @param orig ¿Ĺ
 * @pre origϽѤΤȡ̤ξư
 */
mp_ref_t ymp_dup(mp_cref_t orig)
{
  struct multiprec *p = ymp_malloc(sizeof(struct multiprec));
  if (!p)
    ymp_alloc_error("can't dup struct multiprec", sizeof(struct multiprec));

  ymp_initialize_by_mp(p, orig);
  return p;
}

/**
 * ¿ĹʤȤ len ĤʤdigitĤȤݾڤ
 *
 * ¿Ĺlenİʾdigit򸽺ݻƤϡ⤷ʤ
 * @param self ¿ĹؤΥݥ
 * @param len ݤdigitǿ
 * @pre selfϽѤΤȡ̤ξư
 * @note self->digitsѲ뤫Τʤ
 */
void
ymp_reserve(mp_ref_t self, size_t len)
{
  if (self->len < len) YMP_REALLOC_DIGITS(self, len);
}

/**
 * ¿ĹݻƤ;ʬdigitʲǽʤ˲롣
 *
 * ˤself->digits[]ĹѲȤˤself->lenŬڤꤵ
 * @param self ¿ĹؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 * @post self->sign, self->usedѲʤ
 * @note self->digitsѲ뤫Τʤ
 */
void
ymp_cut_down(mp_ref_t self)
{
  YMP_REALLOC_DIGITS(self, self->used);
}

/** @} */



/** @addtogroup assignment 
 * @{
 */
/**
 * @addtogroup assign_lowlevel ̴ؿ
 * @{
 */
/**
 * ¿Ĺͤǥץԡˤ
 *
 * otherݻƤͤself˥ǥץԡ롣
 * @param self ͤstruct multiprecؤΥݥ
 * @param other ٤ͤݻƤstruct multiprecؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 * @post self->signѲʤ
 */
inline void
ymp_assign_abs(mp_ref_t self, mp_cref_t other)
{
  ymp_reserve(self, other->used);
  self->used = other->used;
  memcpy(self->digits, other->digits, self->used*sizeof(digit_t));
}

/**
 * ¿Ĺͤ@ref digit_t
 *
 * @param self ͤstruct multiprecؤΥݥ
 * @param other ٤digit_t
 * @pre selfϽѤΤȡ̤ξư *
 * @post self->signѲʤ
 */
inline void
ymp_assign_abs_digit(mp_ref_t self, digit_t other)
{
  ymp_reserve(self, 1);
  self->used = 1;
  self->digits[0] = other;
}

/**
 * ¿Ĺ@ref digit_t󤫤ͤ
 *
 * @param self ͤstruct multiprecؤΥݥ
 * @param len arrayݥȤǿ
 * @param array ٤ͤݻƤdigit_tƬؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 * @post self->signѲʤ
 */
inline void
ymp_assign_abs_array(mp_ref_t self, size_t len, const digit_t *array)
{
  self->used = len;
  ymp_reserve(self, len);
  memcpy(self->digits, array, len*sizeof(digit_t));
}

/** @} */



/**
 * ¿Ĺͤǥץԡˤ
 *
 * otherݻƤͤself˥ǥץԡ롣
 * @param self ͤstruct multiprecؤΥݥ
 * @param other ٤ͤݻƤstruct multiprecؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 */
void
ymp_assign(mp_ref_t self, mp_cref_t other)
{
  self->sign = other->sign;
  ymp_assign_abs(self, other);
}


/**
 * ¿Ĺͤ@ref digit_t
 *
 * @param self ͤstruct multiprecؤΥݥ
 * @param other ٤digit_t
 * @pre selfϽѤΤȡ̤ξư
 */
void
ymp_assign_digit(mp_ref_t self, digit_t other)
{
  self->sign = positive_sign;
  ymp_assign_abs_digit(self, other);
}

/**
 * ¿Ĺ@ref digit_t󤫤
 *
 * @param self ͤstruct multiprecؤΥݥ
 * @param len arrayݥȤǿ
 * @param array ٤ͤݻƤdigit_tƬؤΥݥ
 * @pre selfϽѤΤȡ̤ξư
 */
void
ymp_assign_array(mp_ref_t self, size_t len, const digit_t *array)
{
  self->sign = positive_sign;
  ymp_assign_abs_array(self, len, array);
} 



/**
 * @internal
 * ¿Ĺؿƥץ졼
 * @param type 
 * @param postfix ؿ̾դ
 * @param sign_check åݥꥷ
 *                   (@ref to_sign_checkޤ@ref not_to_sign_check)
 */
#define define_ymp_assign_integral_type(type, postfix, sign_check)	\
/**									\
  ¿Ĺ type ͤ					\
  @param self ¿ĹؤΥݥ				\
  @param val 							\
  @pre selfϽѤΤȡ̤ξ硢ư			\
 */									\
void ymp_assign_##postfix(mp_ref_t self, type val)			\
{									\
  do_assign_integral_value(type, self, val, ymp_reserve, sign_check);	\
}

define_ymp_assign_integral_type(signed char, char, to_sign_check);
define_ymp_assign_integral_type(short, short, to_sign_check);
define_ymp_assign_integral_type(int, int, to_sign_check);
define_ymp_assign_integral_type(long, long, to_sign_check);
define_ymp_assign_integral_type(unsigned char, uchar, not_to_sign_check);
define_ymp_assign_integral_type(unsigned short, ushort, not_to_sign_check);
define_ymp_assign_integral_type(unsigned int, uint, not_to_sign_check);
define_ymp_assign_integral_type(unsigned long, ulong, not_to_sign_check);
#ifdef C99
define_ymp_assign_integral_type(intmax_t, intmax, to_sign_check);
define_ymp_assign_integral_type(uintmax_t, uintmax, not_to_sign_check);
#endif

/**
 * ¿Ĺdoubleͤ
 *
 * doubleͤʬ롣 
 * @param self ¿ĹؤΥݥ
 * @param val 
 * @pre selfϽѤΤȡ̤ξ硢ư
 */
void ymp_assign_double(mp_ref_t self, double val)
{
  do_assign_floating_value(double,, "ymp_assign_by_double", ymp_reserve);
}

/**
 * ¿Ĺ2Ѥ
 *
 * <self> := 2**pow
 * @param self ¿ĹؤΥݥ
 * @param pow ѻؿ
 * @pre selfϽѤΤȡ̤ξ硢ư 
 */
void ymp_assign_2exp(mp_ref_t self, size_t pow)
{
  size_t n_digits = pow / DIGIT_BIT, n_bits = pow % DIGIT_BIT;

  self->sign = positive_sign;
  ymp_reserve(self, n_digits+1);
  self->used = n_digits + 1;
  memset(self->digits, 0, sizeof(digit_t)*n_digits);
  self->digits[n_digits] = 1u << n_bits;
}

/**
 * ¿Ĺͤ
 *
 * selfother줾ݻƤͤ򴹤
 * @param self ¿Ĺͤݻstruct multiprecؤΥݥ
 * @param other ¿Ĺͤݻstruct multiprecؤΥݥ
 */
void ymp_swap(mp_ref_t self, mp_ref_t other)
{
  enum mp_sign_t tmp_sign;
  size_t tmp_size;
  digit_t *tmp_digits;

  tmp_sign = self->sign;
  self->sign = other->sign;
  other->sign = tmp_sign;

  tmp_size = self->len;
  self->len = other->len;
  other->len = tmp_size;

  tmp_size = self->used;
  self->used = other->used;
  other->used = tmp_size;

  tmp_digits = self->digits;
  self->digits = other->digits;
  other->digits = tmp_digits;
}

/** @} */
/** @} */
