#include "multiprec.h"
#include <string.h>
#include <math.h>


/** @addtogroup multiprec
 *  @{
 */

/** @addtogroup assignment
 *  @{
 */


/**
 * ʸɽ줿ͤstruct multiprec
 *
 * Τΰ̣strtol(), strtoul()Ʊ
 * @param self ¿ĹؤΥݥ
 * @param psz . 
 * @param endptr NULLǤʤСȤǧǤʤʤäǽΰ֤ؤ
 * ݥ󥿤*endptr˳Ǽ
 * @param radix ʸɽδ0ʤдͤΥץեå
 * ưŪ˷ꤵ
 * 
 * @pre selfϽѤΤȡ̤ξ硢ư
 * @pre 0 <= radix <= 36
 * @exception ymp_error radixϰϳΤȤ
 * @exception ymp_alloc_error ǼΰΥ꡼ݤǤʤȤ
 */
inline void
ymp_assign_string(mp_ref_t self, 
		  const char *psz, char **endptr, unsigned radix)
{
  if (radix > 36)
    ymp_error("ʸ󤫤Ѵδ礭: %u", radix);

  switch (*psz)
    {
    case '-':
      ++psz;
      self->sign = negative_sign;
      break;
    case '+':
      ++psz; /* no break */
    default:
      self->sign = positive_sign;
    }

  if (radix == 0)
    {
      if (*psz != '0') radix = 10;
      else switch (*++psz)
	{
	case 'B': case 'b': radix = 2; ++psz; break;
	case 'Q': case 'q': radix = 4; ++psz; break;
	case 'O': case 'o': radix = 8; ++psz; break;
	case 'D': case 'd': radix = 10; ++psz; break;
	case 'X': case 'x': radix = 16; ++psz; break;
	default: radix = 8; break;
	}
    }

  ymp_reserve(self, ceil(strlen(psz)*(log(radix)/log(MULTIPREC_RADIX)))+1);

  self->used = 0; self->digits[0] = 0;
  for ( ; *psz; ++psz)
    {
      digit_t c;
      switch (*psz)
	{
	case '0': c = 0; break; case '1': c = 1; break;
	case '2': c = 2; break; case '3': c = 3; break;
	case '4': c = 4; break; case '5': c = 5; break;
	case '6': c = 6; break; case '7': c = 7; break;
	case '8': c = 8; break; case '9': c = 9; break;
	case 'A': case 'a': c = 10; break;
	case 'B': case 'b': c = 11; break;
	case 'C': case 'c': c = 12; break;
	case 'D': case 'd': c = 13; break;
	case 'E': case 'e': c = 14; break;
	case 'F': case 'f': c = 15; break;
	case 'G': case 'g': c = 16; break;
	case 'H': case 'h': c = 17; break;
	case 'I': case 'i': c = 18; break;
	case 'J': case 'j': c = 19; break;
	case 'K': case 'k': c = 20; break;
	case 'L': case 'l': c = 21; break;
	case 'M': case 'm': c = 22; break;
	case 'N': case 'n': c = 23; break;
	case 'O': case 'o': c = 24; break;
	case 'P': case 'p': c = 25; break;
	case 'Q': case 'q': c = 26; break;
	case 'R': case 'r': c = 27; break;
	case 'S': case 's': c = 28; break;
	case 'T': case 't': c = 29; break;
	case 'U': case 'u': c = 30; break;
	case 'V': case 'v': c = 31; break;
	case 'W': case 'w': c = 32; break;
	case 'X': case 'x': c = 33; break;
	case 'Y': case 'y': c = 34; break;
	case 'Z': case 'z': c = 35; break;

	case '_': continue;
	default: c = 127;
	}
      if (c >= radix) break;

      ymp_reserve(self, self->used+1);
      self->used
	= ymp_mulabs_digit(self->digits, self->digits, radix, self->used);
      self->used
      	= ymp_addabs(self->digits, self->digits, &c, self->used, 1);
    }
  
  if (endptr) *endptr = (char*)psz;
}

/** @} */
/** @addtogroup construction
 *  @{
 */

/**
 * ʸɽ줿ͤstruct multiprec
 *
 * Τΰ̣strtol(), strtoul()Ʊ
 * @param self ¿ĹؤΥݥ
 * @param psz . 
 * @param endptr NULLǤʤСȤǧǤʤʤäǽΰ֤ؤ
 * ݥ󥿤*endptr˳Ǽ
 * @param radix ʸɽδ0ʤдͤΥץեå
 * ưŪ˷ꤵ
 * 
 * @pre self̤ΤȡѤξ硢ư
 * @pre 0 <= radix <= 36
 * @exception ymp_error radixϰϳΤȤ
 * @exception ymp_alloc_error ǼΰΥ꡼ݤǤʤȤ
 */
void
ymp_initialize_by_string(mp_ref_t self, 
			 const char *psz, char **endptr, unsigned radix)
{
  ymp_initialize(self);
  ymp_assign_string(self, psz, endptr, radix);
}


/** @} */
/** @} */
