#include "multiprec.h"
#include <string.h>

/** @addtogroup multiprec
 *  @{
 */
/** @addtogroup arithmetic
 *  @{
 */
/**
 * @addtogroup lowlevel
 * @{
 */


/**
 * ¿Ĺμ@ref digit_tǳ
 *
 * @param quotient ǼƬؤΥݥ
 *        NULLʤоϳǼʤ
 * @param lhs ɽdigit_tƬؤΥݥ
 * @param rhs 
 * @param lhs_len lhsΥݥȤǿ
 * @pre quotientNULLǤʤʤ顢
 *      ΥݥϺlhs_lenĤǤǼǤ뤳
 * @pre rhs0Ǥʤ
 * @note quotient, lhsϰפƤɤ
 * @return ;
 * @post ;r 0 <= r < rhs
 */
digit_t
ymp_divmodabs_digit(digit_t *quotient, const digit_t *lhs, const digit_t rhs,
		    size_t lhs_len)
{
  double_digit_t tmp = 0;
  register size_t i = lhs_len;
  
  while (i-- > 0)
    {
      tmp = LOW_DIGIT_TO_HIGH_DIGIT(tmp);
      tmp += lhs[i];
      if (quotient) quotient[i] = tmp/rhs;
      tmp %= rhs;
    }
  return LOW_DIGIT(tmp);
}




/**
 * ¿Ĺνμ¹
 *
 * @param quotient ǼƬؤΥݥ
 *        NULLʤоϳǼʤ
 * @param lhs ɽdigit_tƬؤΥݥ.
 *        λˤϡ;Ǽ
 * @param rhs ɽdigit_tƬؤΥݥ
 * @param lhs_len lhsΥݥȤǿ
 * @param rhs_len rhsΥݥȤǿ
 * @pre <rhs>0Ǥʤ
 * @pre lhs_len >= rhs_len
 * @pre quotientNULLǤʤʤ顢
 *      ΥݥϺlhs_len-rhs_len+1ĤǤǼǤ뤳
 * @pre remainderNULLǤʤʤ顢
 *      ΥݥϺrhs_lenĤǤǼǤ뤳
 * @pre quotientlhs, rhsȤϰۤʤ뤳
 * @note <rhs>0ξ硢ư
 * @post ;r 0 <= r < (rhs)
 */
inline static void
do_divmodabs(digit_t *quotient, digit_t *lhs, const digit_t *rhs, 
	     size_t lhs_len, size_t rhs_len)

{
  double_digit_t lhs_top;
  size_t i;

  i = lhs_len; lhs_top = lhs[--i];
  while (i-- >= rhs_len)
    {
      size_t j;
      digit_t q;
      double_digit_t tmp;

      /* Ǿ̷ˤ벾 */
      lhs_top = LOW_DIGIT_TO_HIGH_DIGIT(lhs_top);
      lhs_top += lhs[i];
      q = lhs_top / rhs[rhs_len-1];

      /* ()*() Ƥߤ*/
      tmp = 0;
      for (j=0; j<rhs_len; ++j)
	{
	  double_digit_t tmp2 = MULTIPREC_RADIX;
	  tmp += ((double_digit_t)rhs[j]) * q;

	  tmp2 += lhs[i-rhs_len+j+1];
	  tmp2 -= LOW_DIGIT(tmp);
	  lhs[i-rhs_len+j+1] = LOW_DIGIT(tmp2);

	  tmp = HIGH_DIGIT(tmp);
	  tmp += !HIGH_DIGIT(tmp2);
	}
      tmp = MULTIPREC_RADIX - tmp;
      tmp += lhs[i+1];
      lhs[i+1] = LOW_DIGIT(tmp);

      /* ᤮Ƥ顢Ǿ̷κǾbit1Ȧ */
      while (lhs[i+1] & DIGIT_HIGHEST_BIT) 
	{
	  /* 򸺤餷 */
	  --q;

	  /* ʬ­᤹ */
	  tmp = 0;
	  for (j=0; j<rhs_len; ++j)
	    {
	      tmp += lhs[i-rhs_len+j+1];
	      tmp += rhs[j];
	      lhs[i-rhs_len+j+1] = LOW_DIGIT(tmp);
	      tmp = HIGH_DIGIT(tmp);
	    }
	  lhs[i+1] += LOW_DIGIT(tmp);
	}

      /* 줿񤭹 */
      if (quotient) quotient[i+1-rhs_len] = q;
      
      lhs_top = lhs[i];
    }
}



/**
 * ¿Ĺν
 *
 * @param quotient ǼƬؤΥݥ
 *        NULLʤоϳǼʤ
 * @param remainder ;ǼƬؤΥݥ
 *        NULLʤо;ϳǼʤ
 * @param lhs ɽdigit_tƬؤΥݥ
 * @param rhs ɽdigit_tƬؤΥݥ
 * @param lhs_len lhsΥݥȤǿ
 * @param rhs_len rhsΥݥȤǿ
 * @pre <rhs>0Ǥʤȡ0ξymp_fatal()Ƥ֡
 * @pre lhs_used >= rhs_usedǤ뤳ȡǤʤ
 * @pre quotientNULLǤʤʤ顢
 *      ΥݥϺlhs_len-rhs_len+1ĤǤǼǤ뤳
 * @pre remainderNULLǤʤʤ顢
 *      ΥݥϺrhs_lenĤǤǼǤ뤳
 * @return remainder˳Ǽ줿ǿ
 *  remainderNULLξ0;0ǤȤϡͤɬ0
 * @post ;r 0 <= r < (rhs)
 * @note quotient, remainder, lhs, rhsϰפƤɤ
 */
size_t
ymp_divmodabs(digit_t *quotient, digit_t *remainder,
	      const digit_t *lhs, const digit_t *rhs,
	      size_t lhs_len, size_t rhs_len)
{
  int shift_width; /* ե */
  digit_t hd;      /* rhsκǾ̷ */
  size_t i;
  digit_t *new_lhs, *new_rhs; /* ơեȤ */
  double_digit_t tmp;

  /* 0Ƥ */
  if (rhs_len==0 || (rhs_len==1 && rhs[0]==0))
    {
      ymp_fatal("0ˤ");
      return 0;
    }

  /* եȤǼ뤿ΰ */
  YMP_TEMP_ALLOCATE(new_lhs, digit_t, lhs_len+1);
  YMP_TEMP_ALLOCATE(new_rhs, digit_t, rhs_len);

  /* Ŭڤʥե򻻽 */
  shift_width = 0;
  hd = rhs[rhs_len-1];
  while ( !(hd & DIGIT_HIGHEST_BIT) )
    {
      ++shift_width;
      hd <<= 1;
    }

  /* shift_widthե */
  i = rhs_len; tmp = rhs[--i];
  while (i-- > 0)
    {
      tmp = LOW_DIGIT_TO_HIGH_DIGIT(tmp);
      tmp += rhs[i];
      tmp <<= shift_width;
      new_rhs[i+1] = HIGH_DIGIT(tmp);
      tmp = rhs[i];
    }
  new_rhs[0] = rhs[0] << shift_width;

  /* shift_widthե */
  tmp = 0; i=lhs_len;
  while(i-- > 0)
    {
      tmp += lhs[i];
      tmp <<= shift_width;
      new_lhs[i+1] = HIGH_DIGIT(tmp);

      tmp = lhs[i];
      tmp = LOW_DIGIT_TO_HIGH_DIGIT(tmp);
    }
  new_lhs[0] = lhs[0] << shift_width;

  /* եȤ֤ǡ¹ */
  do_divmodabs(quotient, new_lhs, new_rhs, lhs_len+1, rhs_len);

  /* եȤ줿;new_lhsäƤ */

  if (remainder)
    {
      /* ;եեȤʤ顢0κǹõ */
      size_t rem_used = 0;
      tmp = 0; i=rhs_len;
      while (i-- > 0)
	{
	  tmp += new_lhs[i];
	  remainder[i] = LOW_DIGIT(tmp >> shift_width);

	  if (remainder[i] && !rem_used) rem_used = i+1;

	  tmp = new_lhs[i];
	  tmp = LOW_DIGIT_TO_HIGH_DIGIT(tmp);
	}
      return rem_used;
    }
  else
    {
      return 0;
    }
}
/** @} */



/**
 * ¿Ĺν
 *
 * @param quotient Ǽstruct multiprecؤΥݥ
 *  פʤNULLꤹ
 * @param remainder ;Ǽstruct multiprecؤΥݥ
 *  ;פʤNULLꤹ
 * @param self ɽstruct multiprecؤΥݥ
 * @param other ɽstruct multiprecؤΥݥ
 * @pre selfotherӡ⤷NULLǤʤʤquotientremainderϡ
 *  ѤΤ
 * @pre otherɽ¿Ĺͤ0Ǥʤȡ0ξ硢ymp_fatal()Ƥ֡
 * @pre quotient!=remainder. ư
 * @post  floor(<self> / <other>)Ǥꡢ<self>Ʊ
 * @post ;r0 <= |r| < |<other>|ǡ<self>Ʊ
 */
void
ymp_divmod(mp_ref_t quotient, mp_ref_t remainder, 
	   mp_cref_t self, mp_cref_t other)
{
  enum mp_sign_t rem_sign;
  size_t rem_used;

  /* 0Ƥ */
  if (ymp_is_zero(other))
    {
      ymp_fatal("0ˤ");
      return;
    }

  /* 餫 () < () ʬ:
     0; */
  if (self->used < other->used)
    {
      if (quotient) quotient->used = 0;
      if (self != remainder && remainder) ymp_assign(remainder, self);
      return;
    }

  /* ;γǼ˽ʬΰ */
  if (quotient) ymp_reserve(quotient, self->used-other->used+1);
  if (remainder) ymp_reserve(remainder, other->used);

  /* ƱΤνԤ */
  rem_sign = self->sign;
  rem_used = ymp_divmodabs(quotient?quotient->digits:NULL, 
			   remainder?remainder->digits:NULL, 
			   self->digits, other->digits,
			   self->used, other->used);
  
  /*
   *  remainder==selfޤremainder==otherΤȤˤ
   *  ΤȷĴ˱ƶͿʤ褦ˡ
   *  ;ȷľˤϽ񤭹ޤʤ
   */

  if (quotient)
    {
      /* ȷĴ */
      quotient->sign = self->sign != other->sign;
      quotient->used = self->used - other->used + 1;
      if (!quotient->digits[quotient->used-1]) --quotient->used;
    }

  if (remainder)
    {
      /* ;ȷ񤭹 */
      remainder->sign = rem_sign;
      remainder->used = rem_used;
    }
}


/**
 * ¿ĹΡ@ref digit_tˤ
 *
 * @param quotient Ǽstruct multiprecؤΥݥ
 *  פʤNULLꤹ
 * @param self ɽstruct multiprecؤΥݥ
 * @param other 
 * @pre selfӡ⤷NULLǤʤʤquotientϡѤΤ
 * @return ;
 * @post  floor(<self> / <other>)Ǥꡢ<self>Ʊ
 * @post ;r0 <= r < other
 * @note rhs0ξ硢ymp_fatal()Ƥ֡
 * @note quotient, selfϰפƤɤ
 */
digit_t
ymp_divmod_digit(mp_ref_t quotient, mp_cref_t self, digit_t other)
{
  digit_t rem; /* ; */

  /* 0Ƥ */
  if (other == 0)
    {
      ymp_fatal("0ˤ");
      return 0;
    }

  /* 0ξ硢Ⱦ;0 */
  if (self->used == 0)
    {
      if (quotient) quotient->used = 0;
      return 0;
    }

  /* ǼΤ˽ʬΰ */
  if (quotient) ymp_reserve(quotient, self->used);

  /* ͤνԤ */
  rem = ymp_divmodabs_digit(quotient?quotient->digits:NULL,
			    self->digits,
			    other,
			    self->used);

  /*  */
  if (quotient)
    {
      if (quotient->digits[quotient->used-1]) --quotient->used;
      quotient->sign = self->sign;
    }

  if (self->sign && rem)
    {
      /* ;ˤʤ褦Ĵ */
      if (quotient)
	{
	  quotient->used = ymp_addabs(quotient->digits, quotient->digits, 
				      &other, quotient->len, 1);
	}
      return other - rem;
    }
  else
    {
      return rem;
    }
}

/**
 * ¿Ĺ򡢤⤷ǽʤ
 *
 * selfotherǳ뤫ɤĴ١⤷ڤʤ龦quotient
 * ڤʤȤquotientѲʤ
 * @param quotient Ǽ뤿struct multiprecؤΥݥ󥿡
 * ѤʤNULLꤹ
 * @param self ɽstruct multiprecؤΥݥ󥿡
 * @param other ɽstruct multiprecؤΥݥ󥿡
 * @pre self, otherӡ⤷NULLǤʤʤquotientϡѤΤ
 * @pre otherɽ¿Ĺͤ0Ǥʤȡ0ξ硢ymp_fatal()Ƥ֡
 * @retval 1 selfotherǳڤ줿
 * @retval 0   selfotherǳڤʤ
 * @post ⤷Ǽ줿ʤ顢 floor(<self> / <other>)Ǥꡢ<self>Ʊ
 */
int
ymp_div_if_divisible(mp_ref_t quotient, mp_cref_t self, mp_cref_t other)
{
  size_t rem_used; /* ;η */
  digit_t *quot_buf=NULL, *rem_buf=NULL; /* ;ΰǼ */

  /* 0Ƥ */
  if (ymp_is_zero(other))
    {
      ymp_fatal("0ˤ");
      return 2;
    }

  /* 餫ʾ */
  if (self->used < other->used)
    {
      if (ymp_is_zero(self))
	{
	  if (quotient) quotient->used = 0;
	  return 1;
	}
      else
	{
	  return 0;
	}
    }

  /* Ǽΰ */
  if (quotient) YMP_TEMP_ALLOCATE(quot_buf, digit_t, self->used-other->used+1);
  YMP_TEMP_ALLOCATE(rem_buf, digit_t, other->used);

  /* ͤν¹ */
  rem_used = ymp_divmodabs(quot_buf, rem_buf, self->digits, other->digits,
			   self->used, other->used);

  /* ;0ʤ (ΤȤrem_usedɬ0) */
  if (rem_used==0)
    {
      if (quotient)
	{
	  /* *quotient˾Υǡ򥳥ԡ */
	  size_t quot_used;
	  quotient->sign = self->sign != other->sign;
	  
	  quot_used = self->used - other->used + 1;
	  if (!quot_buf[quot_used-1]) --quot_used;
	  quotient->used = quot_used;
	  ymp_reserve(quotient, quot_used);
	  memcpy(quotient->digits, quot_buf, quot_used);
	}
      return 1;
    }
  else
    {
      return 0;
    }
}



/**
 * ¿Ĺ@ref digit_tǡ⤷ǽʤ
 *
 * selfotherǳ뤫ɤĴ١⤷ڤʤ龦quotient
 * ڤʤȤquotientѲʤ
 * @param quotient Ǽ뤿struct multiprecؤΥݥ󥿡
 * ѤʤNULLꤹ
 * @param self ɽstruct multiprecؤΥݥ󥿡
 * @param other 
 * @pre selfӡ⤷NULLǤʤʤquotientϡѤΤ
 * @pre other0Ǥʤȡ0ξ硢ymp_fatal()Ƥ֡
 * @retval 1 selfotherǳڤ줿
 * @retval 0   selfotherǳڤʤ
 * @post ⤷Ǽ줿ʤ顢 floor(<self> / <other>)Ǥꡢ<self>Ʊ
 */
int
ymp_div_if_divisible_digit(mp_ref_t quotient, mp_cref_t self, digit_t other)
{
  digit_t rem;
  digit_t *quot_buf=NULL;

  /* 0Ƥ */
  if (other == 0)
    {
      ymp_fatal("0ˤ");
      return 2;
    }

  /* 餫ʾ */
  if (ymp_is_zero(self))
    {
      if (quotient) quotient->used = 0;
      return 1;
    }

  /* Ǽΰ */
  if (quotient) YMP_TEMP_ALLOCATE(quot_buf, digit_t, self->used);

  /* ͤν¹ */
  rem = ymp_divmodabs_digit(quot_buf, self->digits, other, self->used);

  /* ;0ʤ */
  if (rem == 0)
    {
      if (quotient)
	{
	  /* *quotient˾Υǡ򥳥ԡ */
	  size_t quot_used;
	  quotient->sign = self->sign;
	  
	  quot_used = self->used;
	  if (!quot_buf[quot_used-1]) --quot_used;
	  quotient->used = quot_used;
	  ymp_reserve(quotient, quot_used);
	  memcpy(quotient->digits, quot_buf, quot_used);
	}
      return 1;
    }
  else
    {
      return 0;
    }
}

/** @} */
/** @} */
