#include "multiprec.h"
#include <stdio.h>
#include <string.h>
#include <assert.h>

/** @addtogroup multiprec
 *  @{
 */
/** @addtogroup output
 *  @{
 */


/** @addtogroup io_lowlevel
 *  @{
 */

static const int digit_prec = DIGIT_BIT/4 + (DIGIT_BIT%4!=0);

/**
 * ¿ĹrɽʸѴ
 *
 * buf[buf_len-1]顢Хåես롣ƬʬϻȤʤΤʤ
 * @param buf ϤХåեƬؤΥݥ
 * @param len bufĹʾϽϤʤ
 * @param mz Ϥstruct multiprecؤΥݥ
 * @param radix ϤɽѤ
 * @return Ϥ줿Хȿ
 * ⤷lenʬǤʤϤǤڤäȤˤϽʬǤäʤ񤭤ޤ줿
 * ǤХȿ֤
 */
inline static int
do_snprint(char *buf, size_t len, mp_cref_t mz, digit_t radix)
{
  int ret = 0;
  size_t tmp_used = mz->used;
  digit_t *tmp;

  if (tmp_used == 0) 
    {
      if (len > 0) buf[len-1] = '0';
      return 1;
    }

  YMP_TEMP_ALLOCATE(tmp, digit_t, tmp_used);
  memcpy(tmp, mz->digits, sizeof(digit_t)*tmp_used);

  do
    {
      digit_t d = ymp_divmodabs_digit(tmp, tmp, radix, tmp_used);
      if (!tmp[tmp_used-1]) --tmp_used;

      if (len-- > 0) buf[len] = "0123456789abcdefghijklmnopqrstuvwxyz"[d];
      
      ++ret;
    } while (tmp_used != 0);

  if (len-- > 0 && mz->sign) {buf[len] = '-'; ++ret;}
  return ret;
}

/**
 * ¿Ĺrɽǥե˽
 *
 * @param fp Υե
 * @param mz Ϥstruct multiprecؤΥݥ
 * @param radix ϤɽѤ
 * @return Ϥ줿Хȿ
 */
int
ymp_fprint(FILE *fp, mp_cref_t mz, digit_t radix)
{
  int ret;
  char *buf;
  size_t buf_len = digit_len_to_str_len(mz->used, radix);

  YMP_TEMP_ALLOCATE(buf, char, buf_len);
  ret = do_snprint(buf, buf_len, mz, radix);
  assert(ret <= buf_len);
  return fwrite(buf+buf_len-ret, 1, ret, fp);
}

/**
 * ¿Ĺrɽʸ˽
 * @param buf ϤХåեƬؤΥݥ
 * @param len bufĹʾϽϤʤ
 * @param mz Ϥstruct multiprecؤΥݥ
 * @param radix ϤɽѤ
 * @return Ϥ줿Хȿ
 * ⤷lenʬǤʤϤǤڤäȤˤϽʬǤäʤ񤭤ޤ줿
 * ǤХȿ֤
 */
int
ymp_snprint(char *buf, size_t len, mp_cref_t mz, digit_t radix)
{
  int ret;
  char *new_buf;
  size_t new_buf_len = digit_len_to_str_len(mz->used, radix);

  YMP_TEMP_ALLOCATE(new_buf, char, new_buf_len);
  ret = do_snprint(new_buf, new_buf_len, mz, radix);
  assert(ret <= new_buf_len);

  if (ret > len) memcpy(buf, new_buf, len);
  else memcpy(buf, new_buf+new_buf_len-ret, ret);
  return ret;
}


/** @} */


/**
 * ¿Ĺ16ɽǴʰ׽
 *
 * @param fp Υե
 * @param mz Ϥstruct multiprecؤΥݥ
 * @return Ϥ줿Хȿ
 */
int ymp_print_hex(FILE *fp, mp_cref_t mz)
{
  int ret = 0;
  size_t i;

  if (mz->sign) { putc('-', fp); ++ret; }

  fputs("0x", fp); ret += 2;

  i = mz->used;
  if (i == 0)
    {
      putc('0', fp); ++ret;
    }
  else
    {
      ret += fprintf(fp, "%x", mz->digits[--i]);
      while (i-- != 0)
	{
	  ret += fprintf(fp, "%0*x", digit_prec, mz->digits[i]);
	}
    }
  return ret;
}


/**
 * ¿Ĺ֤
 *
 * @param fp Υե
 * @param mz פstruct multiprecؤΥݥ
 */
void ymp_dump(FILE *fp, mp_cref_t mz)
{
  size_t i;

  fprintf(fp, "{mz used=%zu len=%zu, ", mz->used, mz->len);
  putc((mz->sign)?'-':'+', fp);
  for (i = 0; i < mz->used; ++i)
    fprintf(fp, " %0*x", digit_prec, mz->digits[i]);
					 
  if (mz->used < mz->len) 
    {
      fputs(" |", fp);
      for ( ; i < mz->len;  ++i)
	fprintf(fp, " %0*x", digit_prec, mz->digits[i]);
    }
  putc('}', fp);
}


/** @} */
/** @} */

