#include "multiprec.h"

/** @addtogroup multiprec
 *  @{
 */
/** @addtogroup misc
 *  @{
 */

/**
 * ceil ( log_2 |n| )
 *
 * @param digits ɽ@ref digit_tƬؤΥݥ
 * @param len digitsݥȤΰĹ(ǿ)
 * @return <self>2пŷؿ<self>0ΤȤ0֤롣
 */
size_t
ymp_abs_clog2(const digit_t *digits, size_t len)
{
  digit_t bit_mask, hd;
  size_t ret, i;

  if (len==0 || (len==1 && digits[0]==0)) return 0;

  ret = len * DIGIT_BIT - 1;

  hd = digits[len-1]; bit_mask = DIGIT_HIGHEST_BIT;
  while (!(bit_mask & hd))
    {
      bit_mask >>= 1;
      --ret; 
    }
  
  if (!UINT_IS_2POW(hd)) return ++ret;

  i = len - 1;
  while (i-- > 0)
    {
      if (digits[i] != 0) ++ret;
    }

  return ret;  
}


/**
 * int( log_2 |n| )
 *
 * @param self ɽstruct multiprecؤΥݥ
 * @return <self>2пʬ<self>0ΤȤ0֤롣
 */
size_t ymp_ilog2(mp_cref_t self)
{
  digit_t bit_mask;
  size_t ret;
  digit_t hd;

  if (ymp_is_zero(self)) return 0;

  ret = self->used * DIGIT_BIT-1; 
  hd = self->digits[self->used-1];
  bit_mask = DIGIT_HIGHEST_BIT;
  while (!(bit_mask & hd))
    {
      bit_mask >>= 1;
      --ret; 
    }

  return ret;
}

/** @} */
/** @} */
