#include "multiprec.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

/** @addtogroup multiprec
 *  @{ */
/** @addtogroup MemoryManagement ưŪ꡼
 *  @{ */

/**
 * ưŪ꡼
 * @param size ݤbyte
 */
void *(*ymp_malloc)(size_t size) = malloc;

/**
 * ưŪ꡼ 
 * @param pv_mem ߳ݤƤΰؤΥݥ
 * @param size ݤbyte
 */
void *(*ymp_realloc)(void *pv_mem, size_t size) = realloc;

/**
 * ꡼
 * @param pv_mem ٤ΰؤΥݥ
 */
void (*ymp_free)(void *pv_mem) = free;

/** @} */

/**
 * @addtogroup Error 顼ϥɥ
 * @{
 */


/**
 * @ref ymp_alloc_errorɸ
 * 
 * stderr˥顼åɽabort().
 */
static void
ymp_alloc_error_default(const char *psz_msg, size_t size)
{
  fprintf(stderr, "[꡼ݼ] %s -- %ubytes\n", psz_msg, size);
  abort();
}

/**
 * @ref ymp_warning, ymp_errorɸ
 * 
 * stderr˥顼åɽ
 */
static void
ymp_error_default(const char *format, ...)
{
  va_list ap;
  va_start(ap, format);
  vfprintf(stderr, format, ap);
  va_end(ap);
  fputc('\n', stderr);
}

/**
 * @ref ymp_fatalɸ
 * 
 * stderr˥顼åɽabort()
 */
static void
ymp_fatal_default(const char *format, ...)
{
  va_list ap;
  va_start(ap, format);
  vfprintf(stderr, format, ap);
  va_end(ap);
  fputc('\n', stderr);
  abort();
}


/**
 * ٹ٥ΥåϤ뤿δؿؤΥݥ
 * 
 * printfߴ
 */
void (*ymp_warning)(const char *format, ...) = ymp_error_default;

/**
 * 顼åϤ뤿δؿؤΥݥ
 * 
 * printfߴ
 */
void (*ymp_error)(const char *format, ...) = ymp_error_default;

/**
 * ̿Ū顼뤿δؿؤΥݥ
 *
 * ݥؿ̿Ū顼ϤƼ¹ԤǤ
 * printfߴ
 */
void (*ymp_fatal)(const char *format, ...) = ymp_fatal_default;

/**
 * ꡼ݤμԤªؿؤΥݥ
 *
 * ݥؿϥåϤƼ¹Ԥ
 * @param psz_msg Ϥå
 * @param size ݤ褦Ȥbyte
 */
void (*ymp_alloc_error)(const char *psz_msg, size_t size) = ymp_alloc_error_default;

/** @} */


/** @addtogroup Util
 *  @{ */

/**
 * ¿Ĺп򳵻
 *
 * lenĤ@ref digit_tɽ줿¿ĹnФrɽǼ˽ʬʸĹ֤
 * @param len digit_tĹ
 * @param r 
 * @pre 2 <= r <= 36. ϰϳξ硢ư
 * @return ceil(log_r(n))ʾμ
 */
size_t digit_len_to_str_len(size_t len, digit_t r)
{
  static const unsigned log_2_r_map[36+1] = {
    0, 0, 1, 1, 2, 2, 2, 2, /* 0-7 */ 
    3, 3, 3, 3, 3, 3, 3, 3, /* 8-15 */
    4, 4, 4, 4, 4, 4, 4, 4, /* 16-23 */
    4, 4, 4, 4, 4, 4, 4, 4, /* 24-31 */
    5, 5, 5, 5, 5           /* 32-36 */
  };

  return len * DIGIT_BIT / log_2_r_map[r] + 1;
}


/** @} */
/** @} */
