#include "multiprec.h"
#include <string.h>

/**
 * ¿ĹѾ躬ʬ
 *
 * result := floor( <self> ** (1/n) )
 * @param result ̤Ǽstruct multiprecؤΥݥ
 * @param self οɽstruct multiprecؤΥݥ
 * @param n ѻؿ
 * @pre nʤСselfǤ뤳ȡ
 *  ǤʤȤymp_fatal()ƤФ롣
 * @pre n0Ǥʤ. ǤʤȤ̤
 */
void
ymp_iroot(mp_ref_t result, mp_cref_t self, size_t n)
{
  /* Newtonˡˤ */

  size_t i;
  size_t ilog2, bit_len;
  struct multiprec x, x_prev; /* ͤݻ */
  struct multiprec tmp;       /* ׻ΰΰ   */
  struct multiprec self_copy;

  if (!self->sign)
    { /* ʤɤ */
      result->sign = positive_sign;
    }
  else
    { /* ǤʤȤ */
      /* 躬ϥ顼 */
      if ( (n & 0x01) == 0) ymp_fatal("ζ躬");

      /* ̤椬 */
      result->sign = self->sign;

      /* ʲ-<self> >= 0 ͤ򻻽Фɤ */
      memcpy(&self_copy, self, sizeof(struct multiprec));
      self_copy.sign = positive_sign;
      self = &self_copy;
    }

  /* bitĹˤꡢͤޤ˷ */
  /* () >= («) ݾڤƼ«٤ʤΤɻߤ */
  /* ilog2 := { 2**k > |<self>|ʤǾk } */
  ilog2 = ymp_ilog2(self); ++ilog2;

  bit_len = ilog2 / n;
  if (bit_len == 0)
    {
      if (ymp_is_zero(self)) ymp_assign_abs_digit(result, 0);
      else                   ymp_assign_abs_digit(result, 1);
      return;
    }
  if (ilog2 % n) ++bit_len;

  ymp_alloca_initialize(&x, self->used * n + 1);
  for (i=0; i<bit_len/DIGIT_BIT; ++i) x.digits[i] = 0;  
  x.digits[i] = 1u << (bit_len%DIGIT_BIT);
  x.used = ++i;

  /* x  (2**k)**n > |<self>| ʤǾ2**k */


  /* ΰ */
  ymp_alloca_initialize(&tmp, self->used * n + 1);
  ymp_alloca_initialize(&x_prev, self->used * n + 1);

  
  /* f(x) = x**n - |<self>| ФNetwonˡ */
  for (;;)
    {
    l_newton_iteration:
      ymp_assign(&x_prev, &x);
      
      /* x_{i+1} = ((n-1) * x_i**n + a) / (n * x_i**(n-1)) */
      ymp_pow(&tmp, &x_prev, n-1);  /* tmp = x_i ** (n-1)  */

      ymp_assign(&x, &tmp);         /* x = x_i ** n */
      ymp_mul(&x, &x, &x_prev);
      ymp_mul_digit(&x, &x, n-1);       /* x = (n-1) * x_i**n  */
      ymp_add(&x, &x, self);        /* (n-1) * x_i**n + a  */
      
      ymp_mul_digit(&tmp, &tmp, n); /* tmp = n*x_i**(n-1)  */
      
      ymp_div(&x, &x, &tmp);        /* x = x_{i+1} */


      if (x.used != x_prev.used) continue;  /* ޤ礭 */

      for (i=1; i<x.used; ++i)
	{
	  if (x.digits[i] != x_prev.digits[i]) /* ޤ礭 */
	    goto l_newton_iteration;           /* Newtonˡ³ */
	}

      /* ʤ«ߤθͤ1ʲʤ顢ȤĴ */
      switch ((int)(x.digits[0] - x_prev.digits[0]))
	{
	case 0:
	  ymp_assign_abs(result, &x);
	  return;

	case 1:
	  for (;;)
	    {
	      ymp_pow(&tmp, &x, n);
	      if (ymp_compare_abs(&tmp, self) > 0) break;
	      ymp_add_digit(&x, &x, 1);
	    }
	  ymp_sub_digit(&x, &x, 1);
	  ymp_assign_abs(result, &x);
	  return;
	  
	case -1:
	  for (;;)
	    {
	      ymp_pow(&tmp, &x, n);
	      if (ymp_compare_abs(&tmp, self) <= 0) break;
	      ymp_sub_digit(&x, &x, 1);
	    }
	  ymp_assign_abs(result, &x);
	  return;
	}
    }
}
