#include "multiprec.h"
#include <string.h>

/** @addtogroup multiprec
 *  @{
 */

/**
 * @addtogroup bit_operation
 * @{
 */


/**
 * @addtogroup bit_lowlevel ̴ؿ
 * @{
 */

/**
 * ¿ĹμФ˸äƥӥåȥեȤԤʤ
 *
 * 줿ʬڤΤƤ롣
 * @param result ̤Ǽ@ref digit_tƬؤΥݥ
 * @param source digit_tƬؤΥݥ
 * @param len sourceݥȤǿ
 * @param width եȤΥӥå
 * @pre resultΥݥȤΰϽʬ礭Ǥ뤳ȡ
 * @note resultΥݥȤΰ¿ȤMAX(0, len-width/DIGIT_BIT)Ĥ
 * ǤǼǤнʬǤ롣
 * @note resultsourceϰפƤ褤
 * @return result˳Ǽ줿ǿ
 */
size_t
ymp_rshiftabs(digit_t *result, const digit_t *source, size_t len, size_t width)
{
  register size_t i;
  size_t n_digits = width / DIGIT_BIT;
  size_t n_bits = width % DIGIT_BIT;
  digit_t prev;

  if (len <= n_digits) return 0;

  i=len; prev=0;
  while (i-- > n_digits)
    {
      double_digit_t tmp = LOW_DIGIT_TO_HIGH_DIGIT((double_digit_t)prev);
      prev = source[i];
      tmp += source[i];
      result[i-n_digits] = LOW_DIGIT(tmp >> n_bits);
    }


  /* ǿĴ */ 
  len -= n_digits;                /* len > n_digits */
  if (result[len-1]==0) --len;

  return len;
}

/**
 * ¿ĹμФ˸äƥӥåȥեȤԤʤ
 *
 * ¦0롣
 * @param result ̤Ǽ@ref digit_tƬؤΥݥ
 * @param source digit_tƬؤΥݥ
 * @param len sourceݥȤǿ
 * @param width եȤΥӥå
 * @pre resultΥݥȤΰϽʬ礭뤳
 * @note resultΥݥȤΰ¿Ȥ(len+width/DIGIT_BIT+1)ĤǤ
 *  ǼǤнʬǤ롣
 * @note resultsourceϰפƤ褤
 * @return result˳Ǽ줿ǿ
 *  Ĺ0ФƤϥեȤԤ鷺ñ0֤
 */
size_t
ymp_lshiftabs(digit_t *result, const digit_t *source, size_t len, size_t width)
{
  register size_t i;
  size_t n_digits = width / DIGIT_BIT;
  size_t n_bits = width % DIGIT_BIT;
  double_digit_t tmp;

  if (len == 0) return 0;
  
  i = len; tmp = source[--i];
  tmp <<= n_bits;
  if (HIGH_DIGIT(tmp)) result[len++ + n_digits] = HIGH_DIGIT(tmp);

  tmp = source[i];
  while (i-- > 0)
    {
      tmp = LOW_DIGIT_TO_HIGH_DIGIT(tmp);
      tmp += source[i];
      result[i+n_digits+1] = HIGH_DIGIT(tmp << n_bits);
      tmp = source[i];
    }
  result[n_digits] = source[0] << n_bits;

  i = n_digits;
  while (i-- > 0) result[i] = 0;
  
  return len + n_digits;
}


/**
 * ¿Ĺ2Ѿˤ;
 *
 * <self>2powǳä;result˳Ǽ롣
 * @param result ;Ǽ@ref digit_tƬؤΥݥ
 * @param self οɽ@ref digit_tƬؤΥݥ
 * @param len  selfΥݥȤΰĹ(ǿ)
 * @param pow ѻؿ
 * @pre result pow / DIGIT_BIT + (pow%DIGIT_BIT)?1:0ĤǤǼǤ뤳
 * @return result˳Ǽ줿ǿ
 * @note selfresultϰפƤ褤
 * @note ǼΰĹϺǤ pow / DIGIT_BIT + 1 нʬ
 */
size_t 
ymp_modabs_2exp(digit_t *result, const digit_t *self, size_t len, size_t pow)
{
  size_t n_digits = pow / DIGIT_BIT;
  size_t n_bits = pow % DIGIT_BIT;

  if (n_digits < len)
    {
      len = n_digits;
      if (n_bits)
	{
	  result[n_digits] = self[n_digits] & ( (1u << n_bits) - 1u );
	  ++n_digits;
	}
    }
  else if (n_digits > len)
    {
      n_digits = len;
    }

  if (result != self) memcpy(result, self, len*sizeof(digit_t));

  while (n_digits-- > 0)
    {
      if (self[n_digits] != 0) break;
    }
  return n_digits+1;
}

/** @} */




/** @} */


/** @addtogroup arithmetic
 *  @{
 */

/**
 * ¿Ĺ2Ѿܤ
 *
 * <self>2powݤѤresult˳Ǽ롣
 * @param result ѤǼstruct multiprecؤΥݥ
 * @param self οɽstruct multiprecؤΥݥ
 * @param pow ѻؿ
 * @note selfresultϰפƤ褤
 */
void ymp_mul_2exp(mp_ref_t result, mp_cref_t self, size_t pow)
{
  result->sign = self->sign;
  ymp_reserve(result, self->used+pow/DIGIT_BIT+1);
  result->used = ymp_lshiftabs(result->digits, self->digits, self->used, pow);
}


/**
 * ¿Ĺ2Ѿǳ
 *
 * <self>2powǳäresult˳Ǽ롣
 * @param result Ǽstruct multiprecؤΥݥ
 * @param self οɽstruct multiprecؤΥݥ
 * @param pow ѻؿ
 * @note selfresultϰפƤ褤
 * @note ڤʤϡ0˶ᤤ򾦤ȤƤȤ롣
 *  @li i.e. <result> = sign(<self>) * floor( |<self>/2**pow| ) Ǥ롣
 *  @li i.e. ;<self>Ʊ
 */
void ymp_div_2exp(mp_ref_t result, mp_cref_t self, size_t pow)
{
  size_t n_shift_digits = pow/DIGIT_BIT;

  if (self->used > n_shift_digits)
    {
      result->sign = self->sign;
      ymp_reserve(result, self->used - n_shift_digits);
      result->used
	= ymp_rshiftabs(result->digits, self->digits, self->used, pow);
    }
  else
    {
      result->used = 0;
    }
}


/**
 * ¿Ĺ2Ѿǳä;
 *
 * <self>2powǳä;result˳Ǽ롣
 * @param result ;Ǽstruct multiprecؤΥݥ
 * @param self οɽstruct multiprecؤΥݥ
 * @param pow ѻؿ
 * @note selfresultϰפƤ褤
 * @post 0 <= |r| < 2**pow Ǥꡢr<self>Ʊ
 */
void ymp_mod_2exp(mp_ref_t result, mp_cref_t self, size_t pow)
{
  size_t n_digits = pow / DIGIT_BIT;
  ymp_reserve(result, n_digits>self->used ? self->used : n_digits);
  result->sign = self->sign;
  result->used = ymp_modabs_2exp(result->digits, self->digits, self->used, pow);
}


/** @} */
/** @} */
