#include "../multiprec.h"
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
void error_handler(const char *format, ...)
{
  va_list ap;
  va_start(ap, format);
  printf("raise <<EOF\n"
	  "YMP ERROR:");
  vprintf(format, ap);
  printf("\nEOF\n");
  va_end(ap);
  exit(1);
}


extern const size_t result_len;
extern const size_t input_len;
extern int (*ptr_test_function)(struct multiprec result[], 
				const struct multiprec input[]);
int main(int argc, char *argv[])
{
  int i;
  int ret;
  struct multiprec input[input_len], result[result_len];

  /* set error handlers */
  ymp_error = error_handler;
  ymp_fatal = error_handler;  

  if (argc <= input_len)
    {
      fprintf(stderr, "argc is too small: %d for %u", argc-1, input_len);
      printf("raise \"argc is too small: %dfor %u\"", argc-1, input_len);
      return EXIT_FAILURE;
    }

  for (i=0; i<input_len; ++i)
    ymp_initialize_by_string(&input[i], argv[i+1], NULL, 0);  

  for (i=0; i<result_len; ++i)
    ymp_initialize(&result[i]);  
  
  ret = ptr_test_function(result, input);
  
  for (i=0; i<input_len; ++i)
    ymp_destroy(&input[i]);

  fputc('[', stdout);
  for (i=0; i<result_len; ++i)
    {
      ymp_print_hex(stdout, &result[i]);
      if (i < result_len-1) fputc(',', stdout);
    }
  fputc(']', stdout);
  
  return ret;
}


